var dns = require('native-dns');
var express = require('express');
var util = require('util');
var url = require('url');

var EventEmitter = require('events').EventEmitter;
var emitter = new EventEmitter();

var app = express();

// cache is broken
dns.platform.cache=false;
// nameserver -- adjust as needed
var localhost = '127.0.0.1';

var question = dns.Question({
    name: '',
    type: 'NAPTR'
});

app.get ('/', function(req, res){
    "use strict";
    res.type('html');
    res.sendfile('expressDNS.html');
});

app.get ('/dns', function(req, res){
    "use strict";
    var label  = url.parse(req.url,true).query.label;
    //  reuse of question object for series of ajax transactions; cf. "fired"
    question.name = label;
    if (emitter.listeners('toBrowser').length > 0 ) {
	emitter.removeAllListeners('toBrowser');
    }
    emitter.on('toBrowser',function (answer) {
	res.send(answer);
    });
    emitter.emit('queryReady', label);
});

var req = dns.Request({
    question: question,
    server: { address: localhost, port: 53, type: 'tcp' },
    timeout: 1000
});


req.on('timeout', function () {
    "use strict";
    console.log('Timeout in making request');
});

req.on('message', function (err, answer) {
    "use strict";
    console.log('message arrived');
    var each ;
    var result = [];
    
    answer.answer.forEach(function (a) {
	var condition = (typeof a.replacement !== 'undefined') && 
	    (a.replacement).length > 0;
	each =  { flags : a.flags, 
		  service: a.service, 
		  value : (condition ? a.replacement : a.regexp)
	    };


        if (!condition && (each.value.length > 0)) {
		sep = each.value.substring(0,1);
                split = each.value.split(sep);
                each.value = split[2];
             }

	result.push(JSON.stringify(each));
	console.log(a.flags + ' ' + a.service );
    });

    emitter.emit('toBrowser', result);
});

var start = '';

req.on('end', function () {
    "use strict";
    var delta = (new Date().getTime()) - start;
    console.log('Finished processing request: ' + delta.toString() + 'ms');
    // toggled back to allow reuse of req and question 
    req.fired=false;
});

emitter.on('queryReady', function () {
    "use strict";

    start = new Date().getTime();
    console.log('starting '+ question.name + start);
    req.send();
});

emitter.on('newListener', function (ev) {
    console.log(ev);
});

app.listen(3004);


